#!/usr/bin/perl
# tip.pl
#
# Matt Kruse
# mkruse@netexpress.net
# http://mkruse.netexpress.net/
# 4/7/98
#
# Modifikation von Gerold Bigorajski
# http://www.gb-direkt.de
# email: bigorajski@t-online.de
# August 22, 1998

use lib ".";

# Eventuell ist der vollstaendige Serverpfad noetig.
require "./tip_config.pl";

#####################################################################

# Leeren des PERL-Puffers.
$|=1;

# Anweisung an den Browser, dass ein HTML-Dokument folgt.
print "Content-type: text/html\n\n";

# Formulardaten lesen und aufbereiten
sub ReadParse
{
	local (*in) = @_ if @_;
	local ($i, $loc, $key, $val);
	if ($ENV{'REQUEST_METHOD'} eq "GET")
	{
		$in = $ENV{'QUERY_STRING'};
	} 
	elsif ($ENV{'REQUEST_METHOD'} eq "POST")
	{
		read(STDIN,$in,$ENV{'CONTENT_LENGTH'});
	}
	@in = split(/&/,$in);
	foreach $i (0 .. $#in)
	{
		$in[$i] =~ s/\+/ /g;
		($key, $val) = split(/=/,$in[$i],2);
		$key =~ s/%(..)/pack("c",hex($1))/ge;
		$val =~ s/%(..)/pack("c",hex($1))/ge;
		$in{$key} .= "\0" if (defined($in{$key})); 
		$in{$key} .= $val;
	}
	return 1;
}

# Formulardaten einlesen
&ReadParse;

# Cookie einlesen
&get_cookie;

# Datumsfunktionen
%MONTHS=(
	'0','Januar','1','Februar','2','Mrz','3','April','4','Mai','5','Juni',
	'6','Juli','7','August','8','September','9','Oktober','10','November','11','Dezember');

# Aktuelle Uhrzeit/aktuelles Datum
($x,$MIN,$HOUR,$MDAY,$MONTH,$YEAR,$x,$x,$x) = localtime(time);
$datestamp = "$MDAY. $MONTHS{$MONTH} 19$YEAR";

# Oeffnen der Datei mit den Tips
open(IN,$tips_file) || die "Kann Tip-Datei $tips_file nicht oeffnen\n";

# Bestimmen der letzten Tipnummer
if($in{'nummer'})
{
	$index = $in{'nummer'};
}
elsif($cookie{'lasttip'})
{
	$index = $cookie{'lasttip'} + 1;
}
else
{
	$index = 1;
}

# Einlesen der Tips und Zuordnung
$n = 1;
while(<IN>)
{
	chomp;
	next unless /^\d/;
	next if /^0/;
	next if /^1000000/;
	($num,$tip[$n]) = split(/\|/,$_,2);

	if ($num == $index + 1)
	{
		$k = $n;
	}
	$n++;
}
close(IN);

# Zyklisches Weiterfuehren von "Back" und "Next"
$items = @tip;
if($index ne "")
{
	$k   = $index;
	if($index == $items)
	{
		$k = 1;
	}
	elsif($index == 0)
	{
		$k = $items - 1;
	}
}
else
{
	$k = 1;
	$index = 1;
}


# Ausgabe der HTML-Datei
print <<"END_OF_HTML";
<HTML>
<HEAD>
<TITLE>Tip des Tages</TITLE>
<BASE HREF="$base_href">
<SCRIPT LANGUAGE=JavaScript>
<!-- 
// Standard-Ablaufzeit ist Morgen nach Mitternacht
var expire = new Date();
expire.setTime(expire.getTime() + ($seconds * 1000));

// Die naechste Zeile ist die, die tatsaechlich verwendet wird - Morgen um Mitternacht einen neuen Tip
// expire.setTime(expire.getTime() + ( (24 - expire.getHours()) * 60 * 60 * 1000)); // Morgen um Mitternacht

if (document.images)
{
	b_close = new Image();
	b_close.src = "close.gif";
	b_closeover = new Image();
	b_closeover.src = "close_highlighted.gif";

	b_back = new Image();
	b_back.src = "back.gif";
	b_backover = new Image();
	b_backover.src = "back_highlighted.gif";

	b_next = new Image();
	b_next.src = "next.gif";
	b_nextover = new Image();
	b_nextover.src = "next_highlighted.gif"
}

function switchimage(string,name)
{
	if (document.images)
	{
		eval("document." + name + ".src = " + string); 
	}
}

function closebutton()
{
	var f = document.forms[0];
	var n;
	if(f.nummer.value != "")
	{
		n = f.nummer.value;
	}
	else
	{
		n = 1;
	}
	n = String(n);
	expire.setTime(expire.getTime() + (365*24*60*60*1000)); // ein Jahr lang gueltig
	if (f.show_tips.checked == false)
	{
		// Keine weiteren Tips
		SetCookie("dont_display_tip",true,null,"/");
	}
	else
	{
		// Weitere Tips
		SetCookie("dont_display_tip",false,null,"/");
	}
	SetCookie("lasttip",n,null,"/");
	window.close();
}

function nextbutton()
{
	var f = document.forms[0];
	var temp = parseInt(f.nummer.value) + 1;
	f.nummer.value = temp;
	f.submit();
}

function backbutton()
{
	var f = document.forms[0];
	var temp = parseInt(f.nummer.value) - 1;
	f.nummer.value = temp;
	f.submit();
}

// Cookie-Funktionen von: http://www.freqgrafx.com/411/library/cookie.js

function getCookieVal (offset)
{
	var endstr = document.cookie.indexOf (";", offset);
	if (endstr == -1)
		endstr = document.cookie.length;
	return unescape(document.cookie.substring(offset, endstr));
}

function GetCookie (name)
{
	var arg = name + "=";
	var alen = arg.length;
	var clen = document.cookie.length;
	var i = 0;
	while (i < clen)
	{
		var j = i + alen;
		if (document.cookie.substring(i, j) == arg)
			return getCookieVal (j);
		i = document.cookie.indexOf(" ", i) + 1;
		if (i == 0)
			break; 
	}
	return " ";
}

function SetCookie (name,value,expires,path,domain,secure)
{
	document.cookie = name + "=" + escape (value) + 
		"; expires=" + expire.toGMTString() + 
		((path) ? "; path=" + path : "") +
		((domain) ? "; domain=" + domain : "") +
		((secure) ? "; secure" : "");
}

//-->
</script>

</HEAD>

<BODY BGCOLOR="#ffffce">

<IMG SRC="lightbulb.gif">
<FONT FACE="arial" SIZE="+2"><B>Tip des Tages:</B></FONT>
<BR><BR>
$tip[$k]
<BR>
<FORM ACTION="../cgi-bin/tip/tip.pl" METHOD=POST>
	<INPUT TYPE="hidden" NAME="nummer" VALUE="$k">
	<INPUT TYPE="hidden" NAME="test" VALUE="$index">
	<hr>
	<INPUT TYPE="CHECKBOX" NAME="show_tips" CHECKED> <B>Tips beim Start zeigen</B>
	<BR><BR>
	<DIV ALIGN=RIGHT>
	<A HREF="javascript:backbutton();" 
		onMouseOver="switchimage('b_backover.src','BACK'); return true;" 
		onMouseOut ="switchimage('b_back.src'    ,'BACK'); return true;" 
		><IMG NAME="BACK" SRC="back.gif"  HSPACE="10" BORDER="0"></A>
	<A HREF="javascript:nextbutton();" 
		onMouseOver="switchimage('b_nextover.src','NEXT'); return true;" 
		onMouseOut ="switchimage('b_next.src'    ,'NEXT'); return true;" 
		><IMG NAME="NEXT" SRC="next.gif"  HSPACE="10" BORDER="0"></A>
	<A HREF="javascript:closebutton();" 
		onMouseOver="switchimage('b_closeover.src','CLOSE'); return true;" 
		onMouseOut ="switchimage('b_close.src'    ,'CLOSE'); return true;" 
		><IMG NAME="CLOSE" SRC="close.gif" HSPACE="10" BORDER="0"></A>
	</DIV>
</FORM>

</BODY>
</HTML>

END_OF_HTML


# Einlesen eines existierenden Cookies
sub get_cookie
{
	local($chip, $val);
	foreach (split(/; /, $ENV{'HTTP_COOKIE'}))
	{
		# Aufsplitten des Cookies fuer jedes Argument (Cookie-Format ist name=wert; name=wert; usw...)
		# Umwandeln von Plus in Leerzeichen (im Falle der Enkodierung (nicht notwenig, aber empfohlen)
		s/\+/ /g;
		# Aufsplitten in Schluessel und Wert beim ersten Gleichheitszeichen  
		($chip, $val) = split(/=/,$_,2);
		# Umwandlen der Hexwerte in alphanumerische Zeichen
		$chip =~ s/%([A-Fa-f0-9]{2})/pack("c",hex($1))/ge;
		$val =~ s/%([A-Fa-f0-9]{2})/pack("c",hex($1))/ge;

		# Erzeugen des assoziativen Arrays.
		 # \1 ist der multiple Separator
		$cookie{$chip} .= "\1" if (defined($cookie{$chip}));
		$cookie{$chip} .= $val;
	}
}

